/* #defines */

#define DATA_PORT    0 /* data node for a PORT command */
#define DATA_PASSIVE 1 /* data node for a PASV command */



/* variables */

struct data_node {

  int socket;                         /* Socket to user's host/port */
  int altsocket;                      /* Socket to shadowftp host/port */

  int type;

  int status;

  unsigned long shadow_host;          /* Shadow FTP's PORT host & port */
  unsigned short int shadow_port;

  unsigned long port_host;            /* PORT's host */
  unsigned short int port_port;       /* PORT's port */

  struct data_node *next;
  struct login_node *login;
};



/* functions */
void data_setfd_set(fd_set *, fd_set *, struct data_node *);
void data_input(fd_set *, fd_set *, struct data_node *);
int data_get(struct data_node *, int, int, int);
void data_close(struct data_node *);
int data_port(struct login_node *, unsigned char *, int, int, int);
int data_pasv(struct login_node *, unsigned char *, int, int, int);
void data_exit_check(struct data_node * );

