#include <stdio.h>
#include <stdlib.h>

#ifndef WIN32 
#include <unistd.h>
#include <sys/errno.h>
#else
#include <winsock.h>
#endif

#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <sys/stat.h>
#include <string.h>

#include "config.h"
#include "io.h"
#include "login.h"
#include "socket.h"
#include "ident.h"

#if defined (SUNOS) || defined (IRIX)
extern int errno;
#endif


extern unsigned int mode_inetd;
extern int server_port;


void set_fdsets(fd_set *r, fd_set *w)
{
  FD_ZERO(r);
  FD_ZERO(w);

  login_setfd_set(r, w);  /* Set all login sockets */
  ident_setfd_set(r, w);  /* Set all ident lookup sockets */

  if (!mode_inetd)
    FD_SET(socket_accept_fd, r);
  
}


int io_exit = 0;


void io(void)
{
  fd_set rset, wset;
  struct timeval tt;
  int nsel;

  while(1) {

	if (io_exit) return ;

    login_exit_check();
    ident_timeout();

    tt.tv_usec = 0;
    tt.tv_sec = PERIOD;
    set_fdsets(&rset, &wset);

#ifdef WIN32
    nsel = select(256, &rset, &wset, NULL, &tt);
#else
    nsel = select(getdtablesize(), &rset, &wset, NULL, &tt);
#endif


    switch(nsel) {
    case -1:
      /* Error */

      
#ifndef WIN32
      if (errno == EINTR)   /* If SUNOS? See #ifdef at top of file */
        continue;
#endif

	  perror("select() exit with error");
	  return;

      break;


    case 0:
      /* Timeout */
      /* Check for time-out logins */
      /*      ident_timeout();*/
      break;

    default:
      /* Input */
      if (!mode_inetd && FD_ISSET(socket_accept_fd, &rset)) {
        printf("New connection triggered\n");
        login_new(socket_accept_fd);

#ifdef WIN32
		/* re-open the damned accept port, stupid MSWProxy */

		//socket_restart();

#endif

      }

      login_input(&rset, &wset);
      ident_input(&rset, &wset);

      break;

    }
  }
}




