/* Defines */

#define ST_NONE 0      /* No status */
#define ST_IDENT    1  /* Ident lookup complete */
#define ST_WRITE    2  /* We're nonblock, and we couldn't write */
#define ST_WRITE2   4  /* We're nonblock, and we couldn't write to altsocket */
#define ST_LOGOUT   8  /* Log this node out */
#define ST_REMOTE  16  /* We have a remote connection */
#define ST_LISTEN  32  /* We're waiting for them to call us (PASV) */
#define ST_PENDING 64  /* Connection pending */
#define ST_ACTIVE 128  /* Connection active, altsocket should be closed too */


/* Variables */

struct login_node {
  unsigned char ident[20];

  unsigned long host;
  unsigned short int port;
  
  unsigned int status;  /* Status bits of this login. */

  int socket;
  int altsocket;

  int data_active;      /* # of active data connections */
  void *data;           /* Data connections, actually a struct data_node * */

  unsigned int inbuffer;   /* Number of bytes already in buffer */
  unsigned char *buffer;/* Input buffer */

  unsigned int outbuffer;  /* Bytes in write() buffer */
  unsigned char *obuffer;  /* ptr to write buffer. often 0. */

  struct login_node *next;
};


/* Functions */

void login_setfd_set(fd_set *, fd_set *);
void login_new(int);
void login_exit(struct login_node *);
void login_input(fd_set *, fd_set *);
void login_get(struct login_node *, int, int);
void login_exit_check(void);
int login_parse(struct login_node *, unsigned char *, int, int, int);
